diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/three-gpp-channel-model.cc ns-3.36/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.35/src/spectrum/model/three-gpp-channel-model.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/three-gpp-channel-model.cc	2022-04-30 18:23:58.146735000 -0700
@@ -1550,67 +1864,74 @@
 
       for (uint64_t sIndex = 0; sIndex < sSize; sIndex++)
         {
-
           Vector sLoc = sAntenna->GetElementLocation (sIndex);
 
-          for (uint8_t nIndex = 0; nIndex < numReducedCluster; nIndex++)
+          for (uint8_t nIndex = 0; nIndex < channelParams->m_reducedClusterNumber; nIndex++)
             {
               //Compute the N-2 weakest cluster, assuming 0 slant angle and a
               //polarization slant angle configured in the array (7.5-22)
-              if (nIndex != cluster1st && nIndex != cluster2nd)
+              if (nIndex != channelParams->m_cluster1st && nIndex != channelParams->m_cluster2nd)
                 {
                   std::complex<double> rays (0,0);
-                  for (uint8_t mIndex = 0; mIndex < raysPerCluster; mIndex++)
+                  for (uint8_t mIndex = 0; mIndex < table3gpp->m_raysPerCluster; mIndex++)
                     {
-                      DoubleVector initialPhase = clusterPhase[nIndex][mIndex];
-                      double k = crossPolarizationPowerRatios[nIndex][mIndex];
+                      DoubleVector initialPhase = channelParams->m_clusterPhase[nIndex][mIndex];
+                      double k = channelParams->m_crossPolarizationPowerRatios[nIndex][mIndex];
                       //lambda_0 is accounted in the antenna spacing uLoc and sLoc.
-                      double rxPhaseDiff = 2 * M_PI * (sin (rayZoa_radian[nIndex][mIndex]) * cos (rayAoa_radian[nIndex][mIndex]) * uLoc.x
-                                                       + sin (rayZoa_radian[nIndex][mIndex]) * sin (rayAoa_radian[nIndex][mIndex]) * uLoc.y
-                                                       + cos (rayZoa_radian[nIndex][mIndex]) * uLoc.z);
-
-                      double txPhaseDiff = 2 * M_PI * (sin (rayZod_radian[nIndex][mIndex]) * cos (rayAod_radian[nIndex][mIndex]) * sLoc.x
-                                                       + sin (rayZod_radian[nIndex][mIndex]) * sin (rayAod_radian[nIndex][mIndex]) * sLoc.y
-                                                       + cos (rayZod_radian[nIndex][mIndex]) * sLoc.z);
-                      // NOTE Doppler is computed in the CalcBeamformingGain function and is simplified to only account for the center anngle of each cluster.
+                      double rxPhaseDiff = 2 * M_PI * (sin (rayZoaRadian[nIndex][mIndex]) * cos (rayAoaRadian[nIndex][mIndex]) * uLoc.x
+                                                       + sin (rayZoaRadian[nIndex][mIndex]) * sin (rayAoaRadian[nIndex][mIndex]) * uLoc.y
+                                                       + cos (rayZoaRadian[nIndex][mIndex]) * uLoc.z);
+
+                      double txPhaseDiff = 2 * M_PI * (sin (rayZodRadian[nIndex][mIndex]) * cos (rayAodRadian[nIndex][mIndex]) * sLoc.x
+                                                       + sin (rayZodRadian[nIndex][mIndex]) * sin (rayAodRadian[nIndex][mIndex]) * sLoc.y
+                                                       + cos (rayZodRadian[nIndex][mIndex]) * sLoc.z);
+                      // NOTE Doppler is computed in the CalcBeamformingGain function and is simplified to only account for the center angle of each cluster.
 
                       double rxFieldPatternPhi, rxFieldPatternTheta, txFieldPatternPhi, txFieldPatternTheta;
-                      std::tie (rxFieldPatternPhi, rxFieldPatternTheta) = uAntenna->GetElementFieldPattern (Angles (rayAoa_radian[nIndex][mIndex], rayZoa_radian[nIndex][mIndex]));
-                      std::tie (txFieldPatternPhi, txFieldPatternTheta) = sAntenna->GetElementFieldPattern (Angles (rayAod_radian[nIndex][mIndex], rayZod_radian[nIndex][mIndex]));
-
-                      rays += (exp (std::complex<double> (0, initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
-                               +exp (std::complex<double> (0, initialPhase[1])) * std::sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                               +exp (std::complex<double> (0, initialPhase[2])) * std::sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                               +exp (std::complex<double> (0, initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
-                        * exp (std::complex<double> (0, rxPhaseDiff))
-                        * exp (std::complex<double> (0, txPhaseDiff));
+                      std::tie (rxFieldPatternPhi, rxFieldPatternTheta) = uAntenna->GetElementFieldPattern (Angles (channelParams->m_rayAoaRadian[nIndex][mIndex], channelParams->m_rayZoaRadian[nIndex][mIndex]));
+                      std::tie (txFieldPatternPhi, txFieldPatternTheta) = sAntenna->GetElementFieldPattern (Angles (channelParams->m_rayAodRadian[nIndex][mIndex], channelParams->m_rayZodRadian[nIndex][mIndex]));
+                      NS_ASSERT (4 <= initialPhase.size ());
+                      rays += (std::complex<double> (cos (initialPhase[0]), sin (initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
+                               std::complex<double> (cos (initialPhase[1]), sin (initialPhase[1])) * std::sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
+                               std::complex<double> (cos (initialPhase[2]), sin (initialPhase[2])) * std::sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
+                               std::complex<double> (cos (initialPhase[3]), sin (initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
+                        * std::complex<double> (cos (rxPhaseDiff), sin (rxPhaseDiff))
+                        * std::complex<double> (cos (txPhaseDiff), sin (txPhaseDiff));
                     }
-                  rays *= sqrt (clusterPower[nIndex] / raysPerCluster);
-                  H_usn[uIndex][sIndex][nIndex] = rays;
+                  rays *= sqrt (channelParams->m_clusterPower[nIndex] / table3gpp->m_raysPerCluster);
+                  hUsn[uIndex][sIndex][nIndex] = rays;
                 }
               else  //(7.5-28)
                 {
-                  std::complex<double> raysSub1 (0,0);
-                  std::complex<double> raysSub2 (0,0);
-                  std::complex<double> raysSub3 (0,0);
+                  std::complex<double> raysSub1 (0, 0);
+                  std::complex<double> raysSub2 (0, 0);
+                  std::complex<double> raysSub3 (0, 0);
 
-                  for (uint8_t mIndex = 0; mIndex < raysPerCluster; mIndex++)
+                  for (uint8_t mIndex = 0; mIndex < table3gpp->m_raysPerCluster; mIndex++)
                     {
-                      double k = crossPolarizationPowerRatios[nIndex][mIndex];
+                      double k = channelParams->m_crossPolarizationPowerRatios[nIndex][mIndex];
 
                       //ZML:Just remind me that the angle offsets for the 3 subclusters were not generated correctly.
+                      DoubleVector initialPhase = channelParams->m_clusterPhase[nIndex][mIndex];
+                      NS_ASSERT (4 <= initialPhase.size ());
 
-                      DoubleVector initialPhase = clusterPhase[nIndex][mIndex];
-                      double rxPhaseDiff = 2 * M_PI * (sin (rayZoa_radian[nIndex][mIndex]) * cos (rayAoa_radian[nIndex][mIndex]) * uLoc.x
-                                                       + sin (rayZoa_radian[nIndex][mIndex]) * sin (rayAoa_radian[nIndex][mIndex]) * uLoc.y
-                                                       + cos (rayZoa_radian[nIndex][mIndex]) * uLoc.z);
-                      double txPhaseDiff = 2 * M_PI * (sin (rayZod_radian[nIndex][mIndex]) * cos (rayAod_radian[nIndex][mIndex]) * sLoc.x
-                                                       + sin (rayZod_radian[nIndex][mIndex]) * sin (rayAod_radian[nIndex][mIndex]) * sLoc.y
-                                                       + cos (rayZod_radian[nIndex][mIndex]) * sLoc.z);
+                      double rxPhaseDiff = 2 * M_PI * (sin (rayZoaRadian[nIndex][mIndex]) * cos (rayAoaRadian[nIndex][mIndex]) * uLoc.x
+                                                       + sin (rayZoaRadian[nIndex][mIndex]) * sin (rayAoaRadian[nIndex][mIndex]) * uLoc.y
+                                                       + cos (rayZoaRadian[nIndex][mIndex]) * uLoc.z);
+                      double txPhaseDiff = 2 * M_PI * (sin (rayZodRadian[nIndex][mIndex]) * cos (rayAodRadian[nIndex][mIndex]) * sLoc.x
+                                                       + sin (rayZodRadian[nIndex][mIndex]) * sin (rayAodRadian[nIndex][mIndex]) * sLoc.y
+                                                       + cos (rayZodRadian[nIndex][mIndex]) * sLoc.z);
 
                       double rxFieldPatternPhi, rxFieldPatternTheta, txFieldPatternPhi, txFieldPatternTheta;
-                      std::tie (rxFieldPatternPhi, rxFieldPatternTheta) = uAntenna->GetElementFieldPattern (Angles (rayAoa_radian[nIndex][mIndex], rayZoa_radian[nIndex][mIndex]));
-                      std::tie (txFieldPatternPhi, txFieldPatternTheta) = sAntenna->GetElementFieldPattern (Angles (rayAod_radian[nIndex][mIndex], rayZod_radian[nIndex][mIndex]));
+                      std::tie (rxFieldPatternPhi, rxFieldPatternTheta) = uAntenna->GetElementFieldPattern (Angles (rayAoaRadian[nIndex][mIndex], rayZoaRadian[nIndex][mIndex]));
+                      std::tie (txFieldPatternPhi, txFieldPatternTheta) = sAntenna->GetElementFieldPattern (Angles (rayAodRadian[nIndex][mIndex], rayZodRadian[nIndex][mIndex]));
+
+                      std::complex<double> raySub = (std::complex<double> (cos (initialPhase[0]), sin (initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
+                                                     std::complex<double> (cos (initialPhase[1]), sin (initialPhase[1])) * sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
+                                                     std::complex<double> (cos (initialPhase[2]), sin (initialPhase[2])) * sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
+                                                     std::complex<double> (cos (initialPhase[3]), sin (initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
+                        * std::complex<double> (cos (rxPhaseDiff), sin (rxPhaseDiff))
+                        * std::complex<double> (cos (txPhaseDiff), sin (txPhaseDiff));
 
                       switch (mIndex)
                         {
@@ -1620,46 +1941,31 @@
                           case 12:
                           case 17:
                           case 18:
-                            raysSub2 += (exp (std::complex<double> (0, initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[1])) * std::sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                                         +exp (std::complex<double> (0, initialPhase[2])) * std::sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
-                              * exp (std::complex<double> (0, rxPhaseDiff))
-                              * exp (std::complex<double> (0, txPhaseDiff));
+                            raysSub2 += raySub;
                             break;
                           case 13:
                           case 14:
                           case 15:
                           case 16:
-                            raysSub3 += (exp (std::complex<double> (0, initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[1])) * std::sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                                         +exp (std::complex<double> (0, initialPhase[2])) * std::sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
-                              * exp (std::complex<double> (0, rxPhaseDiff))
-                              * exp (std::complex<double> (0, txPhaseDiff));
+                            raysSub3 += raySub;
                             break;
                           default:                      //case 1,2,3,4,5,6,7,8,19,20
-                            raysSub1 += (exp (std::complex<double> (0, initialPhase[0])) * rxFieldPatternTheta * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[1])) * std::sqrt (1 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                                         +exp (std::complex<double> (0, initialPhase[2])) * std::sqrt (1 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                                         +exp (std::complex<double> (0, initialPhase[3])) * rxFieldPatternPhi * txFieldPatternPhi)
-                              * exp (std::complex<double> (0, rxPhaseDiff))
-                              * exp (std::complex<double> (0, txPhaseDiff));
+                            raysSub1 += raySub;
                             break;
                         }
                     }
-                  raysSub1 *= sqrt (clusterPower[nIndex] / raysPerCluster);
-                  raysSub2 *= sqrt (clusterPower[nIndex] / raysPerCluster);
-                  raysSub3 *= sqrt (clusterPower[nIndex] / raysPerCluster);
-                  H_usn[uIndex][sIndex][nIndex] = raysSub1;
-                  H_usn[uIndex][sIndex].push_back (raysSub2);
-                  H_usn[uIndex][sIndex].push_back (raysSub3);
-
+                  raysSub1 *= sqrt (channelParams->m_clusterPower[nIndex] / table3gpp->m_raysPerCluster);
+                  raysSub2 *= sqrt (channelParams->m_clusterPower[nIndex] / table3gpp->m_raysPerCluster);
+                  raysSub3 *= sqrt (channelParams->m_clusterPower[nIndex] / table3gpp->m_raysPerCluster);
+                  hUsn[uIndex][sIndex][nIndex] = raysSub1;
+                  hUsn[uIndex][sIndex].push_back (raysSub2);
+                  hUsn[uIndex][sIndex].push_back (raysSub3);
                 }
             }
-          if (los) //(7.5-29) && (7.5-30)
+
+          if (channelParams->m_losCondition == ChannelCondition::LOS) //(7.5-29) && (7.5-30)
             {
-              std::complex<double> ray (0,0);
+              std::complex<double> ray (0, 0);
               double rxPhaseDiff = 2 * M_PI * (sin (uAngle.GetInclination ()) * cos (uAngle.GetAzimuth ()) * uLoc.x
                                                + sin (uAngle.GetInclination ()) * sin (uAngle.GetAzimuth ()) * uLoc.y
                                                + cos (uAngle.GetInclination ()) * uLoc.z);
@@ -1674,94 +1980,36 @@
               double lambda = 3e8 / m_frequency; // the wavelength of the carrier frequency
 
               ray = (rxFieldPatternTheta * txFieldPatternTheta - rxFieldPatternPhi * txFieldPatternPhi)
-                * exp (std::complex<double> (0, -2 * M_PI * dis3D / lambda))
-                * exp (std::complex<double> (0, rxPhaseDiff))
-                * exp (std::complex<double> (0, txPhaseDiff));
+                * std::complex<double> (cos (-2 * M_PI * distance3D / lambda), sin (-2 * M_PI * distance3D / lambda))
+                * std::complex<double> (cos (rxPhaseDiff), sin (rxPhaseDiff))
+                * std::complex<double> (cos (txPhaseDiff), sin (txPhaseDiff));
 
-              double K_linear = pow (10,K_factor / 10);
+              double kLinear = pow (10, channelParams->m_K_factor / 10);
               // the LOS path should be attenuated if blockage is enabled.
-              H_usn[uIndex][sIndex][0] = sqrt (1 / (K_linear + 1)) * H_usn[uIndex][sIndex][0] + sqrt (K_linear / (1 + K_linear)) * ray / pow (10,attenuation_dB[0] / 10);           //(7.5-30) for tau = tau1
-              double tempSize = H_usn[uIndex][sIndex].size ();
+              hUsn[uIndex][sIndex][0] = sqrt (1 / (kLinear + 1)) * hUsn[uIndex][sIndex][0] + sqrt (kLinear / (1 + kLinear)) * ray / pow (10, channelParams->m_attenuation_dB[0] / 10);           //(7.5-30) for tau = tau1
+              double tempSize = hUsn[uIndex][sIndex].size ();
               for (uint8_t nIndex = 1; nIndex < tempSize; nIndex++)
                 {
-                  H_usn[uIndex][sIndex][nIndex] *= sqrt (1 / (K_linear + 1)); //(7.5-30) for tau = tau2...taunN
+                  hUsn[uIndex][sIndex][nIndex] *= sqrt (1 / (kLinear + 1)); //(7.5-30) for tau = tau2...taunN
                 }
-
             }
         }
     }
 
-  // store the delays and the angles for the subclusters
-  if (cluster1st == cluster2nd)
+  NS_LOG_DEBUG ("Husn (sAntenna, uAntenna):" << sAntenna->GetId () << ", " << uAntenna->GetId ());
+  for (auto& i:hUsn)
     {
-      clusterDelay.push_back (clusterDelay[cluster1st] + 1.28 * table3gpp->m_cDS);
-      clusterDelay.push_back (clusterDelay[cluster1st] + 2.56 * table3gpp->m_cDS);
-
-      clusterAoa.push_back (clusterAoa[cluster1st]);
-      clusterAoa.push_back (clusterAoa[cluster1st]);
-
-      clusterZoa.push_back (clusterZoa[cluster1st]);
-      clusterZoa.push_back (clusterZoa[cluster1st]);
-
-      clusterAod.push_back (clusterAod[cluster1st]);
-      clusterAod.push_back (clusterAod[cluster1st]);
-
-      clusterZod.push_back (clusterZod[cluster1st]);
-      clusterZod.push_back (clusterZod[cluster1st]);
-    }
-  else
-    {
-      double min, max;
-      if (cluster1st < cluster2nd)
-        {
-          min = cluster1st;
-          max = cluster2nd;
-        }
-      else
+      for (auto& j:i)
         {
-          min = cluster2nd;
-          max = cluster1st;
+          for (auto& k:j)
+            {
+              NS_LOG_DEBUG (" " << k << ",");
+            }
         }
-      clusterDelay.push_back (clusterDelay[min] + 1.28 * table3gpp->m_cDS);
-      clusterDelay.push_back (clusterDelay[min] + 2.56 * table3gpp->m_cDS);
-      clusterDelay.push_back (clusterDelay[max] + 1.28 * table3gpp->m_cDS);
-      clusterDelay.push_back (clusterDelay[max] + 2.56 * table3gpp->m_cDS);
-
-      clusterAoa.push_back (clusterAoa[min]);
-      clusterAoa.push_back (clusterAoa[min]);
-      clusterAoa.push_back (clusterAoa[max]);
-      clusterAoa.push_back (clusterAoa[max]);
-
-      clusterZoa.push_back (clusterZoa[min]);
-      clusterZoa.push_back (clusterZoa[min]);
-      clusterZoa.push_back (clusterZoa[max]);
-      clusterZoa.push_back (clusterZoa[max]);
-
-      clusterAod.push_back (clusterAod[min]);
-      clusterAod.push_back (clusterAod[min]);
-      clusterAod.push_back (clusterAod[max]);
-      clusterAod.push_back (clusterAod[max]);
-
-      clusterZod.push_back (clusterZod[min]);
-      clusterZod.push_back (clusterZod[min]);
-      clusterZod.push_back (clusterZod[max]);
-      clusterZod.push_back (clusterZod[max]);
-
-
     }
-
-  NS_LOG_INFO ("size of coefficient matrix =[" << H_usn.size () << "][" << H_usn[0].size () << "][" << H_usn[0][0].size () << "]");
-
-  channelParams->m_channel = H_usn;
-  channelParams->m_delay = clusterDelay;
-
-  channelParams->m_angle.clear ();
-  channelParams->m_angle.push_back (clusterAoa);
-  channelParams->m_angle.push_back (clusterZoa);
-  channelParams->m_angle.push_back (clusterAod);
-  channelParams->m_angle.push_back (clusterZod);
-
-  return channelParams;
+  NS_LOG_INFO ("size of coefficient matrix =[" << hUsn.size () << "][" << hUsn[0].size () << "][" << hUsn[0][0].size () << "]");
+  channelMatrix->m_channel = hUsn;
+  return channelMatrix;
 }
 
 std::pair<double, double>
@@ -1769,11 +2017,11 @@
 {
   inclinationRad = WrapTo2Pi (inclinationRad);
   if (inclinationRad > M_PI)
-  {
-    // inclination must be in [0, M_PI]
-    inclinationRad -= M_PI;
-    azimuthRad += M_PI;
-  }
+    {
+      // inclination must be in [0, M_PI]
+      inclinationRad -= M_PI;
+      azimuthRad += M_PI;
+    }
 
   azimuthRad = WrapTo2Pi (azimuthRad);
 
@@ -1786,7 +2034,7 @@
 }
 
 MatrixBasedChannelModel::DoubleVector
-ThreeGppChannelModel::CalcAttenuationOfBlockage (Ptr<ThreeGppChannelModel::ThreeGppChannelMatrix> params,
+ThreeGppChannelModel::CalcAttenuationOfBlockage (const Ptr<ThreeGppChannelModel::ThreeGppChannelParams> channelParams,
                                                  const DoubleVector &clusterAOA,
                                                  const DoubleVector &clusterZOA) const
 {
@@ -1802,25 +2050,22 @@
 
   //step b:Generate the size and location of each blocker
   //generate self blocking (i.e., for blockage from the human body)
-  double phi_sb, x_sb, theta_sb, y_sb;
   //table 7.6.4.1-1 Self-blocking region parameters.
+  // Defaults: landscape mode
+  double phiSb = 40;
+  double xSb = 160;
+  double thetaSb = 110;
+  double ySb = 75;
   if (m_portraitMode)
     {
-      phi_sb = 260;
-      x_sb = 120;
-      theta_sb = 100;
-      y_sb = 80;
-    }
-  else // landscape mode
-    {
-      phi_sb = 40;
-      x_sb = 160;
-      theta_sb = 110;
-      y_sb = 75;
+      phiSb = 260;
+      xSb = 120;
+      thetaSb = 100;
+      ySb = 80;
     }
 
   //generate or update non-self blocking
-  if (params->m_nonSelfBlocking.size () == 0) //generate new blocking regions
+  if (channelParams->m_nonSelfBlocking.size () == 0) //generate new blocking regions
     {
       for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
         {
@@ -1841,12 +2086,12 @@
               table.push_back (5);  //y_k
               table.push_back (10);  //r
             }
-          params->m_nonSelfBlocking.push_back (table);
+          channelParams->m_nonSelfBlocking.push_back (table);
         }
     }
   else
     {
-      double deltaX = sqrt (pow (params->m_preLocUT.x - params->m_locUT.x, 2) + pow (params->m_preLocUT.y - params->m_locUT.y, 2));
+      double deltaX = sqrt (pow (channelParams->m_preLocUT.x - channelParams->m_locUT.x, 2) + pow (channelParams->m_preLocUT.y - channelParams->m_locUT.y, 2));
       //if deltaX and speed are both 0, the autocorrelation is 1, skip updating
       if (deltaX > 1e-6 || m_blockerSpeed > 1e-6)
         {
@@ -1859,7 +2104,7 @@
             }
           else
             {
-              if (params->m_channelCondition->IsO2i ()) // outdoor to indoor
+              if (channelParams->m_o2iCondition == ChannelCondition::O2I) // outdoor to indoor
                 {
                   corrDis = 5;
                 }
@@ -1872,7 +2117,7 @@
           if (m_blockerSpeed > 1e-6) // speed not equal to 0
             {
               double corrT = corrDis / m_blockerSpeed;
-              R = exp (-1 * (deltaX / corrDis + (Now ().GetSeconds () - params->m_generatedTime.GetSeconds ()) / corrT));
+              R = exp (-1 * (deltaX / corrDis + (Now ().GetSeconds () - channelParams->m_generatedTime.GetSeconds ()) / corrT));
             }
           else
             {
@@ -1880,7 +2125,7 @@
             }
 
           NS_LOG_INFO ("Distance change:" << deltaX << " Speed:" << m_blockerSpeed
-                                          << " Time difference:" << Now ().GetSeconds () - params->m_generatedTime.GetSeconds ()
+                                          << " Time difference:" << Now ().GetSeconds () - channelParams->m_generatedTime.GetSeconds ()
                                           << " correlation:" << R);
 
           //In order to generate correlated uniform random variables, we first generate correlated normal random variables and map the normal RV to uniform RV.
@@ -1898,8 +2143,8 @@
             {
 
               //Generate a new correlated normal RV with the following formula
-              params->m_nonSelfBlocking[blockInd][PHI_INDEX] =
-                R * params->m_nonSelfBlocking[blockInd][PHI_INDEX] + sqrt (1 - R * R) * m_normalRv->GetValue ();
+              channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] =
+                R * channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] + sqrt (1 - R * R) * m_normalRv->GetValue ();
             }
         }
 
@@ -1912,21 +2157,23 @@
       NS_ASSERT_MSG (clusterZOA[cInd] >= 0 && clusterZOA[cInd] <= 180, "the ZOA should be the range of [0,180]");
 
       //check self blocking
-      NS_LOG_INFO ("AOA=" << clusterAOA[cInd] << " Block Region[" << phi_sb - x_sb / 2 << "," << phi_sb + x_sb / 2 << "]");
-      NS_LOG_INFO ("ZOA=" << clusterZOA[cInd] << " Block Region[" << theta_sb - y_sb / 2 << "," << theta_sb + y_sb / 2 << "]");
-      if ( std::abs (clusterAOA[cInd] - phi_sb) < (x_sb / 2) && std::abs (clusterZOA[cInd] - theta_sb) < (y_sb / 2))
+      NS_LOG_INFO ("AOA=" << clusterAOA[cInd] << " Block Region[" << phiSb - xSb / 2 << ","
+                          << phiSb + xSb / 2 << "]");
+      NS_LOG_INFO ("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaSb - ySb / 2 << ","
+                          << thetaSb + ySb / 2 << "]");
+      if (std::abs (clusterAOA[cInd] - phiSb) < (xSb / 2)
+          && std::abs (clusterZOA[cInd] - thetaSb) < (ySb / 2))
         {
           powerAttenuation[cInd] += 30;               //anttenuate by 30 dB.
-          NS_LOG_INFO ("Cluster[" << (int)cInd << "] is blocked by self blocking region and reduce 30 dB power,"
+          NS_LOG_INFO ("Cluster[" << +cInd << "] is blocked by self blocking region and reduce 30 dB power,"
                        "the attenuation is [" << powerAttenuation[cInd] << " dB]");
         }
 
       //check non-self blocking
-      double phiK, xK, thetaK, yK;
       for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
         {
           //The normal RV is transformed to uniform RV with the desired correlation.
-          phiK = (0.5 * erfc (-1 * params->m_nonSelfBlocking[blockInd][PHI_INDEX] / sqrt (2))) * 360;
+          double phiK = (0.5 * erfc (-1 * channelParams->m_nonSelfBlocking[blockInd][PHI_INDEX] / sqrt (2))) * 360;
           while (phiK > 360)
             {
               phiK -= 360;
@@ -1937,9 +2184,10 @@
               phiK += 360;
             }
 
-          xK = params->m_nonSelfBlocking[blockInd][X_INDEX];
-          thetaK = params->m_nonSelfBlocking[blockInd][THETA_INDEX];
-          yK = params->m_nonSelfBlocking[blockInd][Y_INDEX];
+          double xK = channelParams->m_nonSelfBlocking[blockInd][X_INDEX];
+          double thetaK = channelParams->m_nonSelfBlocking[blockInd][THETA_INDEX];
+          double yK = channelParams->m_nonSelfBlocking[blockInd][Y_INDEX];
+
           NS_LOG_INFO ("AOA=" << clusterAOA[cInd] << " Block Region[" << phiK - xK << "," << phiK + xK << "]");
           NS_LOG_INFO ("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaK - yK << "," << thetaK + yK << "]");
 
@@ -1986,26 +2234,24 @@
                   signZ2 = 1;
                 }
               double lambda = 3e8 / m_frequency;
-              double F_A1 = atan (signA1 * M_PI / 2 * sqrt (M_PI / lambda *
-                                                            params->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (A1)) - 1))) / M_PI; //(7.6-23)
-              double F_A2 = atan (signA2 * M_PI / 2 * sqrt (M_PI / lambda *
-                                                            params->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (A2)) - 1))) / M_PI;
-              double F_Z1 = atan (signZ1 * M_PI / 2 * sqrt (M_PI / lambda *
-                                                            params->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (Z1)) - 1))) / M_PI;
-              double F_Z2 = atan (signZ2 * M_PI / 2 * sqrt (M_PI / lambda *
-                                                            params->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (Z2)) - 1))) / M_PI;
-              double L_dB = -20 * log10 (1 - (F_A1 + F_A2) * (F_Z1 + F_Z2));                  //(7.6-22)
-              powerAttenuation[cInd] += L_dB;
-              NS_LOG_INFO ("Cluster[" << (int)cInd << "] is blocked by no-self blocking, "
-                           "the loss is [" << L_dB << "]" << " dB");
-
+              double fA1 = atan (signA1 * M_PI / 2 * sqrt (M_PI / lambda *
+                                                           channelParams->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (A1)) - 1))) / M_PI; //(7.6-23)
+              double fA2 = atan (signA2 * M_PI / 2 * sqrt (M_PI / lambda *
+                                                           channelParams->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (A2)) - 1))) / M_PI;
+              double fZ1 = atan (signZ1 * M_PI / 2 * sqrt (M_PI / lambda *
+                                                           channelParams->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (Z1)) - 1))) / M_PI;
+              double fZ2 = atan (signZ2 * M_PI / 2 * sqrt (M_PI / lambda *
+                                                           channelParams->m_nonSelfBlocking[blockInd][R_INDEX] * (1 / cos (DegreesToRadians (Z2)) - 1))) / M_PI;
+              double lDb = -20 * log10 (1 - (fA1 + fA2) * (fZ1 + fZ2));                  //(7.6-22)
+              powerAttenuation[cInd] += lDb;
+              NS_LOG_INFO ("Cluster[" << +cInd << "] is blocked by no-self blocking, the loss is ["
+                                      << lDb << "] dB");
             }
         }
     }
   return powerAttenuation;
 }
 
-
 void
 ThreeGppChannelModel::Shuffle (double * first, double * last) const
 {
@@ -2022,7 +2268,8 @@
   m_normalRv->SetStream (stream);
   m_uniformRv->SetStream (stream + 1);
   m_uniformRvShuffle->SetStream (stream + 2);
-  return 3;
+  m_uniformRvDoppler->SetStream (stream + 3);
+  return 4;
 }
 
 }  // namespace ns3
